from typing import Type

from astra_installer.settings.manager import SettingsManager
from astra_installer.utils import Utils


class License:
    @staticmethod
    def load(settings: Type[SettingsManager]) -> str:
        filename = 'license_{locale}.txt'.format(locale=settings.installer_locale.selected)
        path = Utils.file_path(settings.systeminfo.scripts_path, filename)
        with open(path, 'r') as file:
            return file.read()
