from astra_installer.commands import run_command
from astra_installer.logs.hardware_reporter import HardwareReporter
from astra_installer.logs.logger import Logger


class SystemLogSaver:
    @staticmethod
    def save_logs(directory: str) -> None:
        Logger.log('Saving logs to {dir}'.format(dir=directory))
        run_command('mkdir -p {dir}'.format(dir=directory))
        SystemLogSaver.save_hardware_summary(directory)
        SystemLogSaver.save_system_logs(directory)

    @staticmethod
    def save_system_logs(directory: str) -> None:
        args = {'expect_success': False, 'enable_logging': False}
        run_command('cp /etc/lsb-release {dir}'.format(dir=directory), **args)
        run_command('cp /var/lib/dpkg/status {dir}'.format(dir=directory), **args)
        run_command('cp /var/log/syslog {dir}'.format(dir=directory), **args)
        run_command('cp /var/log/Xorg.0.log {dir}'.format(dir=directory), **args)

    @staticmethod
    def save_hardware_summary(directory: str) -> None:
        reporter = HardwareReporter()
        hardware_summary = reporter.hardware_summary()
        filename = '{dir}/hardware-summary'.format(dir=directory)
        with open(filename, 'w') as file:
            file.write(hardware_summary)
            file.write('\n')
