from typing import Optional, List

from astra_installer.settings.component import Component, ComponentId


class Archive(Component):
    def __init__(self, ident: ComponentId, name: str, desc: str,
                 enabled: bool, selected: bool, visible: bool,
                 priority: float, dependencies: List[ComponentId], path: str, size: Optional[int]) -> None:
        super().__init__(ident, name, desc, desc, enabled, selected, visible, priority, dependencies)
        self.path = path
        self.size = size

    def __str__(self) -> str:
        return self.path
