from astra_installer.commands import Chroot
from astra_installer.logs.logger import Logger
from astra_installer.settings.manager import SettingsManager


class HostnameInstall:
    def __init__(self) -> None:
        self.chroot = Chroot(SettingsManager.disk.target_path)

    def get_hosts_content(self) -> str:
        text = """127.0.0.1       localhost
127.0.1.1       {hostname}

# The following lines are desirable for IPv6 capable hosts
::1     localhost ip6-localhost ip6-loopback
ff02::1 ip6-allnodes
ff02::2 ip6-allrouters
""".format(hostname=SettingsManager.hostname.hostname)
        return text

    def set_hosts(self) -> None:
        self.chroot.create_file('/etc/hosts', self.get_hosts_content())

    def set_hostname(self) -> None:
        self.chroot.create_file('/etc/hostname', SettingsManager.hostname.hostname)

    def install(self) -> None:
        Logger.log('Setting hostname to {name}'.format(name=SettingsManager.hostname.hostname))
        self.set_hosts()
        self.set_hostname()
