from astra_installer.commands import Chroot
from astra_installer.logs.logger import Logger
from astra_installer.settings.manager import SettingsManager


class LayoutInstall:
    def __init__(self) -> None:
        self.chroot = Chroot(SettingsManager.disk.target_path)

    def set_keyboard_settings(self) -> None:
        self.chroot.create_file('/etc/default/keyboard', SettingsManager.layout.export_xkbdata().keyboard_content())

    def install(self) -> None:
        Logger.log('Setting keyboard options')
        self.set_keyboard_settings()
