from astra_installer.commands import Chroot
from astra_installer.logs.logger import Logger
from astra_installer.settings.manager import SettingsManager


class TimezoneInstall:
    def __init__(self) -> None:
        self.chroot = Chroot(SettingsManager.disk.target_path)

    def install(self) -> None:
        timezone = SettingsManager.timezone.selected
        Logger.log('Setting timezone to {timezone}'.format(timezone=timezone))
        self.chroot.run_command('ln -sf /usr/share/zoneinfo/{timezone} /etc/localtime'.format(timezone=timezone))
        self.chroot.create_file('/etc/timezone', timezone)
