from astra_installer.settings.manager import SettingsManager
from astra_installer.setup.archive.disk import DiskInstallArchive
from astra_installer.storage.utils.storage import get_device_uuid


class DiskInstallMIPS(DiskInstallArchive):
    def __init__(self) -> None:
        super().__init__()

    def setup_bootloader(self) -> None:
        uuid = get_device_uuid(SettingsManager.storage.current_template.storage_state.root_partition().path)
        command = "sed -e \"s|^ROOT=.*|ROOT=UUID={uuid}|\" -i boot/barebox/barebox.sh".format(uuid=uuid)
        self.chroot.run_command(command)
