import re

from astra_installer.commands import run_command
from astra_installer.settings.manager import SettingsManager
from astra_installer.setup.common.hostname import HostnameInstall
from astra_installer.utils import ConfigWriter, FilePath


class HostnameInstallOEM(HostnameInstall):
    def __init__(self) -> None:
        super().__init__()

    def set_hosts(self) -> None:
        oldhostname = run_command('hostname').stdout[0]
        hostname = SettingsManager.hostname.hostname
        regex = r'^(?!\s*#)\s*(?P<ip>[\d\.]+)\s+{hostname}\s+.*$'.format(hostname=oldhostname)
        record = '{ip}\t{alias}'

        def modify_line(line: str):
            match = re.match(regex, line)
            if match:
                return record.format(ip=match.group('ip'), alias=hostname)
            else:
                return None

        default = record.format(ip='127.0.1.1', alias=hostname)
        ConfigWriter(FilePath('/etc/hosts'), self.chroot).read().modify(modify_line, default).write()
