from collections import Iterable

from npyscreen import MultiLine, BoxTitle


class IterableMultiLine(MultiLine):
    def display_value(self, item: Iterable) -> None:
        value = item
        if isinstance(item, Iterable):
            value = next(iter(item), None)
        return super().display_value(value)

    def get_selected_objects(self):
        value = self.value
        if value is not None:
            value = self.values[self.value]
        return value


class IterableBoxTitle(BoxTitle):
    _contained_widget = IterableMultiLine
