from threading import Timer
from typing import Callable


class WaitLauncher:
    def __init__(self, time: float, main_task: Callable, wait_task: Callable) -> None:
        self.__time = time
        self.__main_task = main_task
        self.__wait_task = wait_task
        self.__m_args = {}
        self.__m_kwargs = {}
        self.__w_args = {}
        self.__w_kwargs = {}

    def set_main_args(self, *args, **kwargs) -> None:
        self.__m_args = args
        self.__m_kwargs = kwargs

    def set_wait_args(self, *args, **kwargs) -> None:
        self.__w_args = args
        self.__w_kwargs = kwargs

    def run(self) -> None:
        timer = Timer(self.__time, self.__wait_task, *self.__w_args, **self.__w_kwargs)
        timer.start()
        self.__main_task(*self.__m_args, **self.__m_kwargs)
        timer.cancel()
