#!/usr/bin/env python3

from astra_installer.utils import Utils
from astra_installer_console.arg_parser import create_arg_parser


def main() -> None:
    if not Utils.check_dependencies():
        exit(1)

    from astra_installer_console.console_installer import ConsoleInstaller
    from astra_installer_console.autoinstaller import AutoInstaller

    parser = create_arg_parser()
    arguments = parser.parse_args()

    if arguments.preseed or Utils.preseed_file_available() or Utils.preseed_cmdline_option():
        preseed_file = AutoInstaller.preseed_file(arguments.preseed)
        console_installer = AutoInstaller(arguments.locale, preseed_file)
    else:
        console_installer = ConsoleInstaller(arguments.locale)
    console_installer.run()
    console_installer.run_last_command()


if __name__ == '__main__':
    main()
