import curses.ascii
from typing import Optional, Callable

from npyscreen import FixedText

from astra_installer_console.ui.grub_settings_dialog import GrubSettingsDialog


class GrubButton(FixedText):
    def __init__(self, *args, **kwargs):
        self.__settings_changed_callback = kwargs.get('settings_changed_callback', None)  # type: Optional[Callable]
        self.__settings_dialog = None  # type: Optional[GrubSettingsDialog]
        super().__init__(*args, **kwargs)
        self.__setup()

    def __setup(self) -> None:
        self.__settings_dialog = GrubSettingsDialog(parentApp=self.parent.parentApp,
                                                    name=self.name,
                                                    settings_changed_callback=self.__settings_changed_callback)

    def set_up_handlers(self) -> None:
        super().set_up_handlers()
        self.handlers.update({curses.ascii.SP: self.h_change_value,
                              curses.ascii.NL: self.h_change_value})

    def h_change_value(self, _: str) -> None:
        self.__settings_dialog.edit()
