from typing import TYPE_CHECKING

from npyscreen import Popup, MultiLine, FixedText

if TYPE_CHECKING:
    from gettext import gettext as _


class PopupMultiline(Popup):
    class MultilineText(MultiLine):  # TODO: hacks... do a complete override of all methods
        def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            self.move_cursor_to_value()

        def move_cursor_to_value(self):
            self.cursor_line = self.value
            start_display_at = self.cursor_line - len(self._my_widgets) + 1
            self.start_display_at = start_display_at if start_display_at > 0 else 0

        def update(self, clear=True):
            super().update()
            if self.start_display_at > 0:
                self.parent.above_text.hidden = False
            else:
                self.parent.above_text.hidden = True
            self.parent.above_text.display()

    def __init__(self, values=None, current_index: int = 0, *args, **kwargs):
        self.value = None
        self.multiline = None  # type: MultiLine
        self.above_text = None  # type: FixedText
        super().__init__(*args, **kwargs)
        self.create_widgets(values, current_index)

    def create_widgets(self, values, current_index: int = 0):
        self.nextrely = 1
        self.above_text = self.add(FixedText,
                                   value='- {text} -'.format(text=_('above')),
                                   editable=False,
                                   hidden=True)
        self.above_text.color = 'CONTROL'

        self.multiline = self.add(PopupMultiline.MultilineText,
                                  values=values,
                                  return_exit=True,
                                  select_exit=True,
                                  slow_scroll=True,
                                  value=current_index)

    def edit(self):
        self.display()
        self.multiline.edit()
        self.value = self.multiline.value
