from typing import TYPE_CHECKING

from astra_installer.settings.manager import SettingsManager
from astra_installer_console.ui.checkbox_callback import CheckBoxCallback

if TYPE_CHECKING:
    from gettext import gettext as _


class RebootManager:
    def __init__(self, form, max_widgets_width: int = None):
        self.form = form
        self.reboot_checkbox = None  # type: CheckBoxCallback
        self.backend = SettingsManager.disk
        self.setup(max_widgets_width)

    def setup(self, max_widgets_width: int) -> None:
        self.backend.reboot_after_install = True
        self.form.add(CheckBoxCallback,
                      name=_('Reboot computer after installation is complete'),
                      value=self.backend.reboot_after_install,
                      toggled_callback=self.reboot_toggled,
                      max_width=max_widgets_width - 1)

    def reboot_toggled(self, value: bool):
        self.backend.reboot_after_install = value
