from typing import Iterable

from npyscreen import ActionPopup

from astra_installer.tui.iterable_multi_line import IterableMultiLine


class SelectionDialog(ActionPopup):
    def __init__(self, items: Iterable = None, *args, **kwargs):
        self.items = items
        self.actions_widget = None  # type: IterableMultiLine
        self.value = None
        super().__init__(*args, **kwargs)

    def create_control_buttons(self) -> None:
        pass

    def create(self) -> None:
        self.actions_widget = self.add(IterableMultiLine,
                                       values=self.items,
                                       select_exit=True)

    def edit(self) -> None:
        self.display()
        self.actions_widget.edit()
        if self.actions_widget.value is not None:
            try:
                self.value = self.actions_widget.values[self.actions_widget.value]
            except IndexError:
                return
