from typing import Optional, TYPE_CHECKING

from astra_installer_console.ui.base_main_form import BaseMainForm
from astra_installer_console.ui.storage_title import StorageTitle

if TYPE_CHECKING:
    from gettext import gettext as _


class StorageManager:
    def __init__(self, parent: BaseMainForm, select_widgets_at: int, max_width: int):
        self.__parent = parent
        self.__storage_title = None  # type: Optional[StorageTitle]
        self.__setup(select_widgets_at, max_width)

    def __setup(self, select_widgets_at: int, max_width: int) -> None:
        self.__storage_title = self.__parent.add(StorageTitle,
                                                 name=_('Device partitioning scheme:'),
                                                 begin_entry_at=select_widgets_at,
                                                 max_width=max_width)
