from npyscreen import ComboBox

from astra_installer_console.ui.popup_multiline import PopupMultiline
from astra_installer_console.ui.title_widget import TitleWidget


class ComboBoxPair(ComboBox):
    def __init__(self, widget=None, selection_changed_callback=None, *args, **kwargs):
        self.selection_changed_callback = selection_changed_callback
        self._old_value = kwargs.get('value', None)
        super().__init__(widget, value_changed_callback=self.selection_changed, *args, **kwargs)

    def display_value(self, value):
        text, data = value
        return text

    def selection_changed(self, widget):
        if callable(self.selection_changed_callback):
            text, data = self.values[self.value]
            self.selection_changed_callback(data)

    def get_current_value(self):
        text, data = self.values[self.value]
        return data

    def h_change_value(self, input):
        form = PopupMultiline(name=self.name,
                              values=[self.display_value(x) for x in self.values],
                              current_index=self.value)
        form.edit()
        self.value = form.value


class TitleComboBoxPair(TitleWidget):
    _entry_type = ComboBoxPair

    def get_current_value(self):
        return self.entry_widget.get_current_value()
