from npyscreen import TitleText


class TitleWidget(TitleText):
    def __init__(self, *args, **kwargs):
        self.value = kwargs.get('value', None)
        super().__init__(*args, **kwargs)

    def get_value(self):
        if hasattr(self, 'entry_widget'):
            return self.entry_widget.value
        elif hasattr(self, '_tmp_value'):
            return self._tmp_value
        else:
            return None

    def set_value(self, value):
        if hasattr(self, 'entry_widget'):
            self.entry_widget.value = value
        else:
            self._tmp_value = value

    def del_value(self):
        del self.entry_widget.value

    value = property(get_value, set_value, del_value)
