from os import execl, execle, environ

from astra_installer.settings.manager import SettingsManager
from astra_installer.utils import Utils

preseed_available = Utils.preseed_available()
preseed_argument = Utils.preseed_argument()

keypress_waiting_time = 30


def run_astra_installer_qt() -> None:
    env = environ.copy()
    env['LANG'] = SettingsManager.installer_locale.selected
    execle('/usr/bin/xinit', '/usr/bin/xinit', env)


main_menu_list = [
    {'text_en_US': 'Graphic installation',
     'text_ru_RU': 'Графическая установка',
     'execute': run_astra_installer_qt,
     'exit_and_execute': True,
     'execute_if_preseed': False},

    {'text_en_US': 'Console installation',
     'text_ru_RU': 'Консольная установка',
     'execute': lambda: execl('/usr/bin/astra-installer-console',
                              '/usr/bin/astra-installer-console',
                              '--locale',
                              SettingsManager.installer_locale.selected,
                              '--preseed',
                              preseed_argument if preseed_argument else ''),
     'exit_and_execute': True,
     'execute_if_preseed': preseed_available}
]
