import weakref

from astra_installer.tui.iterable_multi_line import IterableMultiLine
from astra_installer_launcher.ui.form_with_footer import FormWithFooter


class SelectForm(FormWithFooter):
    def __init__(self, items, *args, **keywords):
        self.items = items
        self.selected_widget = None
        super().__init__(*args, **keywords)

    def create(self) -> None:
        self.selected_widget = self.add(IterableMultiLine,
                                        select_exit=True,
                                        values=self.items)

    def edit_loop(self) -> bool:
        self.editing = True
        self.display()
        while not (self._widgets__[self.editw].editable and not self._widgets__[self.editw].hidden):
            self.editw += 1
            if self.editw > len(self._widgets__) - 1:
                self.editing = False
                return False

        while self.editing:
            if not self.ALL_SHOWN: self.on_screen()
            self.while_editing(weakref.proxy(self._widgets__[self.editw]))
            self._during_edit_loop()
            if not self.editing:
                break
            self._widgets__[self.editw].edit()
            self._widgets__[self.editw].display()

            self.handle_exiting_widgets(self._widgets__[self.editw].how_exited)

            if self.editw < 1:
                self.editing = False

        return True

    def post_edit_loop(self) -> None:
        self.exit(self.selected_widget.get_selected_objects())

    def h_cancel(self, input) -> None:
        self.exit()

    def exit(self, value=None) -> None:
        self.set_value(value)
        for widget in self._widgets__:
            widget.editing = False
        self.editing = False
